<template>
  <div :id="id" :class="className" :style="{height:height,minWidth:width}" />
</template>

<script>
import echarts from 'echarts'
import resize from './mixins/resize'

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    id: {
      type: String,
      default: 'chart'
    },
    title: {
      type: String,
      default: 'line'
    },
    width: {
      type: String,
      default: '500px'
    },
    height: {
      type: String,
      default: '400px'
    },
    lineData: {
      type: Array,
      default: () => {
        return []
      }
    },
    description: {
      type: String,
      default: ''
    },
    config: {
      type: Object,
      default: () => {
        return {}
      }
    },
    format: {
      type: String,
      default: 'HH:mm:ss'
    },
    step: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      chart: null
    }
  },
  watch: {
    lineData: function(val) {
      this.updateChart(val)
    }
  },
  mounted() {
    this.initChart()
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    updateChart(data) {
      console.log(data)
      const xAxis = []
      const series = []
      data.forEach(v => {
        xAxis.push(v[0])
        series.push(v[1])
      })
      this.chart.setOption({
        xAxis: {
          data: xAxis
        },
        series: [{
          type: 'line',
          showSymbol: false,
          clip: true,
          data: series
        }]
      })
    },
    initChart() {
      this.chart = echarts.init(document.getElementById(this.id))
      let config = {
        tooltip: {},
        xAxis: {
          name: 'x',
          minorTick: {
            show: true
          },
          splitLine: {
            lineStyle: {
              color: '#999'
            }
          },
          minorSplitLine: {
            show: true,
            lineStyle: {
              color: '#ddd'
            }
          }
        },
        yAxis: {
          name: 'y',
          minorTick: {
            show: true
          },
          splitLine: {
            lineStyle: {
              color: '#999'
            }
          },
          minorSplitLine: {
            show: true,
            lineStyle: {
              color: '#ddd'
            }
          }
        },
        series: [{
          type: 'line',
          showSymbol: false,
          clip: true,
          data: this.lineData
        }]
      }
      config = {
        ...config,
        ...this.config
      }

      this.chart.setOption(config)
    }
  }
}
</script>
